<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Call-By-Ref Parameters</TITLE>
<link href="suif1_91.html" rel=Next>
<link href="suif1_89.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_89.html">previous</A>, <A HREF="suif1_91.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC90" HREF="suif1_toc.html#TOC90">Call-By-Reference Parameters</A></H2>
<P>
<A NAME="IDX649"></A>

</P>
<P>
Procedure parameters in Fortran are passed by reference.  SUIF uses
call-by-value parameters and implements call-by-reference parameters by
passing pointers to the actual arguments.  When the formal parameters
are used, the pointers must be dereferenced.  However, one of the
primary advantages of compiling Fortran programs is that there are no
pointers in the source code.  If not for the call-by-reference parameter
pointers, most compiler passes that only deal with Fortran can be
simplified by not having to deal with pointers.  Thus the SUIF Fortran
form automatically converts the code to make it appear that the
parameters are passed by reference.  The parameters are changed to
call-by-reference types instead of pointers and the pointer dereferences
are temporarily removed.

</P>
<P>
<A NAME="IDX650"></A>
<A NAME="IDX651"></A>
The <CODE>make_ref_params</CODE> function is used to convert call-by-reference
parameters in a procedure to the Fortran form.  It must be called before
converting the procedure body to expression trees.  This is done
automatically by the <CODE>read_proc</CODE> method for a <CODE>proc_sym</CODE> if
the <CODE>use_fortran_form</CODE> flag is set.  Before writing a procedure to
an output file, the call-by-reference parameters must be converted back
to pointers using the <CODE>undo_ref_params</CODE> function.  Since it is
illegal to write out a procedure in the Fortran form, the
<CODE>write_proc</CODE> method for the <CODE>proc_sym</CODE> always calls
<CODE>undo_ref_params</CODE>; you do not need to call it directly.  Both
<CODE>make_ref_params</CODE> and <CODE>undo_ref_params</CODE> are defined in the
file <TT>`callbyref.cc'</TT>.

</P>
<P>
The Fortran front-end must identify call-by-reference formal parameters
by putting <CODE>call_by_ref</CODE> annotations (see section <A HREF="suif1_76.html#SEC76">Call-By-Reference Annotations</A>)
on the pointer types used by those parameters.  Before actually changing
the type of a call-by-reference parameter and removing its dereferences,
<CODE>make_ref_params</CODE> checks that the pointer parameter is neither
addressed nor assigned within the procedure.  If this check fails, the
pointer is not a valid call-by-reference parameter, so
<CODE>make_ref_params</CODE> prints a warning message and does not convert
that parameter.  Otherwise, it goes ahead and changes the type of the
parameter from a pointer to a call-by-reference type (see section <A HREF="suif1_67.html#SEC67">Modifier Types</A>).  Any dereferences of that pointer within the procedure are
removed, and other references to the pointer are changed to <CODE>ldc</CODE>
(load constant) instructions that take the address of the parameter.
The end result of all this is that it appears that the parameters are
passed by reference.  Note that the call sites are not changed; the
actual arguments for call-by-reference parameters are still passed as
pointers.

</P>
<P>
The <CODE>undo_ref_params</CODE> function does as its name suggests and undoes
the transformations applied by <CODE>make_ref_params</CODE>.  The only
potential complication is that while in the Fortran form the user may
have used the call-by-reference parameters in ways that cannot be
expressed outside of the Fortran form.  Specifically, the
call-by-reference parameters cannot be used as index variables of
<CODE>for</CODE> loops (see section <A HREF="suif1_17.html#SEC17">For Nodes</A>), and they cannot be used as bounds
in array types (see section <A HREF="suif1_63.html#SEC63">Array Types</A>).  Both of those uses require direct
references to variable symbols, and there is no place to insert the
pointer dereferences required outside of Fortran form.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_89.html">previous</A>, <A HREF="suif1_91.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
